
-- ͻ
--        D E S I G N   E N G I N E R I N G              DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         Package     Os2.dlg                                        
--                                                                    
--         Author :  Leonid Dulman     1997                           
--                                                                    
--              GNU ADA RUNTIME LIBRARY (GNARL) COMPONENTS            
--                                                                    
--              OS/2 Presentation Manager CUA controls                
--                       and dialogs declarations                     
-- ͼ

with System   ;

package body Os2.dlg is

Null_Char: constant character := character'val(0);

procedure InitDlgField(fild: out FILEDLG;               -- Dialog Record
                       fo  : TypeDlg := OpenDialog) is  -- File Operation

begin

fild.cbSize      :=  328; -- ULONG (FILEDLG'size/8);  -- Size of FILEDLG structure.
fild.fl          := FDS_HELPBUTTON or FDS_CENTER or
                    FDS_OPEN_DIALOG ; -- FDS_ flags. Alter behavior of dlg.
fild.ulUser      :=  0      ;  -- User defined field. Ulong
fild.lReturn     :=  0      ;  -- Result code from dialog dismissal.  LONG
fild.lSRC        :=  0      ;  -- System return code.                 LONG

case fo is                     -- String to display in title bar.     PSZ
  when OpenDialog   =>  fild.pszTitle  := pszOpen(1)'address ;
  when SaveAsDialog =>  fild.pszTitle  := pszSaveAs(1)'address ;
end case;

fild.pszOKButton :=            -- String to display in OK button.     PSZ
      System.Null_Address;
fild.pfnDlgProc  :=            -- Entry point to custom dialog proc.  PFNWP
      System.Null_Address;
fild.pszIType    :=            -- Pointer to string containing        PSZ
      System.Null_Address;     -- initial EA type filter. Type
                               -- does not have to exist in list.
fild.papszITypeList  :=        -- Pointer to table of pointers that    PAPSZ
      System.Null_Address;     -- point to null terminated Type
                               -- strings. End of table is marked
                               -- by a NULL pointer.
fild.pszIDrive       :=        -- Pointer to string containing          PSZ
      System.Null_Address;     -- initial drive. Drive does not
                               -- have to exist in drive list.
fild.papszIDriveList :=        -- Pointer to table of pointers that     PAPSZ
      System.Null_Address;     -- point to null terminated Drive
                               -- strings. End of table is marked
                               --  by a NULL pointer.
fild.hMod             := 0    ;-- Custom File Dialog template.     HMODULE
fild.szFullFile       :=       -- Initial or selected fully  FullFileStr
     (others => Null_Char); -- qualified path and file.
fild.papszFQFilename  :=       -- Pointer to table of pointers that  PAPSZ
      System.Null_Address;     -- point to null terminated FQFname
                               -- strings. End of table is marked
                               --  by a NULL pointer.
fild.ulFQFCount       := 0   ; -- Number of files selected       ULONG
fild.usDlgId          := 0   ; -- Custom dialog id.              USHORT
fild.x                := 0   ; -- X coordinate of the dialog     SHORT
fild.y                := 0   ; -- Y coordinate of the dialog     SHORT
fild.sEAType          := 0   ; -- Selected file's EA Type.       SHORT


fild.szFullFile(1..3):= "*.*"; -- Initial path,file name, or file filter
end       InitDlgField;
end os2.dlg ;
