-- ͻ
--        D E S I G N   E N G I N E R I N G              DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         Package     Os2.Jba                                        
--                                                                    
--         Author :  Leonid Dulman     1996 , 1997                    
--                                                                    
--              GNU ADA RUNTIME LIBRARY (GNARL) COMPONENTS            
--                                                                    
--              Interface to Visual Developer JBA International       
--                                                                    
-- ͼ
with os2.pmhp ; use os2.pmhp ;
with os2.pmcp ; use os2.pmcp ;
with os2.bse  ; use os2.bse  ;
with builtin  ; use builtin  ;
with Ada.Unchecked_conversion;
package body Os2.Jba is

type ULLOHM is record
ul  : ULONG   ;
lo  : LONG    ;
hm  : HMODULE ;
end record;

-- function GuiMakeImage (p1:ULONG; p2:long; p3:HMODULE) return  ULONG is
-- function MakeImage (p:ULLOHM) return  ULONG ;
-- pragma Import(c,MakeImage, Link_name=>"_MakeImage__F6ULLOHM");
-- p: ULLOHM ;
-- begin
--  p.ul := p1;
--  p.lo := p2;
--  p.hm := p3;
--  return MakeImage (p);
-- end GuiMakeImage;

type PFLOPW is record
pf : PFNMOD  ;
lo : LONG    ;
pw : PWINDOW ;
end record ;

function GuiCreateThread (p1:PFNMOD; p2:long; p3:PWINDOW) return Thread  is
function CreateThread (p:PFLOPW ) return Thread ;
pragma Import(c,CreateThread, Link_name=>"_CreateThread");
p : PFLOPW ;
begin
  p.pf := p1;
  p.lo := p2;
  p.pw := p3;
  return CreateThread(p) ;
end GuiCreateThread ;

type    Title  is record   -- Fiction type need for one parameter procedure
   t1   : GuiStr;
   t2   : GuiStr;
end record ;

procedure GuiInitApp  (p1 :string; p2: string) is
procedure InitApp  (p :Title);
pragma Import(c,InitApp, Link_name=>"_InitApp");
p: Title ;
begin
  p.t1 := To_guistr(p1);
  p.t2 := To_guistr(p2);
  InitApp  (p);
end GuiInitApp ;

type STHM is record
st : GuiStr ;
hm : HMODULE ;
end record ;

procedure   GuiSetHlpFile  (p1:string; p2:HMODULE) is
procedure   SetHlpFile  (p:STHM );
pragma Import(c,SetHlpFile, Link_name=>"_SetHlpFile");
p: STHM ;
begin
  p.st := To_Guistr(p1);
  p.hm := p2 ;
  SetHlpFile  (p);
end GuiSetHlpFile ;

type INPC is record
 p1 : integer ;
 pc : pchar   ;
end record ;

procedure   GuiSaveCmdLine  (p1:integer;p2: pchar) is
procedure   SaveCmdLine  (p:INPC);
pragma Import(c,SaveCmdLine, Link_name=>"_SaveCmdLine");
p: INPC ;
begin
 p.p1 := p1 ;
 p.pc := p2 ;
 SaveCmdLine  (p);
end GuiSaveCmdLine ;

type LOLO is record
  lo1 : LONG;
  lo2 : LONG;
end record ;

procedure   GuiSound (p1:LONG; p2:LONG) is
-- procedure   Sound (p :LOLO);
-- pragma Import(c,Sound, Link_name=>"_Sound");
-- p : LOLO ;
rc : APIRET;
begin
rc := DosBeep(Ulong(p1),Ulong(p2));
--  p.lo1 := p1 ;
--  p.lo2 := p2 ;
--  Sound (p);
end GuiSound ;

type LOHM is record
lo : LONG ;
hm : HMODULE ;
end record ;

type LOHMGS is record
lo : LONG ;
hm : HMODULE ;
gs : GuiStr  ;
end record ;
type PLOHMGS is access all  LOHMGS ;

function GuiStrTable (p1:LONG; p2:HMODULE) return String  is
procedure StrTable (p: PLOHMGS) ;
pragma Import(c,StrTable, Link_name=>"_StrTable");
p : aliased LOHMGS;
begin
p.lo := p1 ;
p.hm := p2 ;
StrTable (p'unchecked_access) ;
return From_Guistr(p.gs);
end GuiStrTable ;

type PMLOUL is record
pm : PMESSAGE ;
lo : LONG ;
ul : ULONG ;
end record ;

procedure   GuiSetMsg (p1:PMESSAGE; p2:LONG; p3:ULONG) is
procedure   SetMsg (p:PMLOUL );
pragma Import(c,SetMsg, Link_name=>"_SetMsg");
p: PMLOUL ;
begin
  p.pm := p1;
  p.lo := p2;
  p.ul := p3;
  SetMsg (p);
end GuiSetMsg ;

type PWPMGSGS is record
pw : PWINDOW;
pm : PMESSAGE;
gs1: GuiStr;
gs2: GuiStr;
end record ;

function GuiShowMsg (p1:PWINDOW; p2:PMESSAGE; p3:string; p4:string)  return SHORT is
function ShowMsg (p :PWPMGSGS) return SHORT;
pragma Import(c,ShowMsg, Link_name=>"_ShowMsg");
p:PWPMGSGS ;
begin
  p.pw := p1;
  p.pm := p2;
  p.gs1:= To_guistr(p3);
  p.gs2:= To_guistr(p4);
  return ShowMsg (p) ;
end GuiShowMsg ;

type PWPMG is record
pw : PWINDOW;
pm : PMESSAGE;
end record ;

function  GuiInvokeMsg (p1:PWINDOW; p2:PMESSAGE) return SHORT is
function  InvokeMsg (p :PWPMG) return SHORT;
pragma Import(c,InvokeMsg, Link_name=>"_InvokeMsg");
p:PWPMG ;
begin
  p.pw := p1;
  p.pm := p2;
  return InvokeMsg (p);
end GuiInvokeMsg ;

type GSGSLO is record
  gs1 : GuiStr;
  gs2 : GuiStr;
  lo  : LONG  ;
end record ;

function  GuiRunProgram (p1:string; p2:string;p3: LONG) return LONG  is
function  RunProgram (p :GSGSLO) return LONG ;
pragma Import(c,RunProgram, Link_name=>"_RunProgram");
p :GSGSLO ;
begin
  p.gs1 := To_guistr(p1);
  p.gs2 := To_guistr(p2);
  p.lo  := p3 ;
  return RunProgram (p);
end GuiRunProgram ;

type LOSH is record
lo : LONG ;
sh : SHORT;
end record ;

function GuiWaitProgram (p1:LONG; p2:SHORT) return LONG  is
function WaitProgram (p :LOSH) return LONG ;
pragma Import(c,WaitProgram, Link_name=>"_WaitProgram");
p :LOSH ;
begin
p.lo := p1;
p.sh := p2;
return WaitProgram (p);
end GuiWaitProgram ;

function  GuiRandom (p1:LONG;p2:LONG) return LONG  is
function  Random (p :LOLO) return LONG ;
pragma Import(c,Random, Link_name=>"_Random");
p :LOLO ;
begin
p.lo1:= p1;
p.lo2:= p2;
return Random (p);
end GuiRandom ;

type LOLOGS is record
lo1: LONG ;
lo2: LONG ;
gs : GuiStr;
end record ;

function GuiError (p1:LONG;p2:LONG;p3:string) return BOOL is
function Error (p :LOLOGS ) return BOOL;
pragma Import(c,Error, Link_name=>"_Error");
p :LOLOGS ;
begin
p.lo1:= p1;
p.lo2:= p2;
p.gs := To_guiStr(p3);
return Error  (p);
end GuiError;

type PCULMPMP is record
pc : pchar;
ul : ULONG;
mp1: PMPARAM ;
mp2: PMPARAM ;
end record ;

procedure   GuiDebugMsg (p1:pchar;p2: ULONG;p3:PMPARAM;p4: PMPARAM) is
procedure   DebugMsg (p:PCULMPMP );
pragma Import(c,DebugMsg, Link_name=>"_DebugMsg");
p:PCULMPMP ;
begin
  p.pc := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  DebugMsg (p);
end GuiDebugMsg ;

type HAPQUS is record
ha : HAB;
pq : PQMSG ;
us : USHORT ;
end record ;

function GuiMsgFilter (p1:HAB; p2:PQMSG; p3:USHORT) return BOOL is
function MsgFilter (p :HAPQUS ) return BOOL;
pragma Import(c,MsgFilter, Link_name=>"_MsgFilter");
p :HAPQUS ;
begin
  p.ha := p1 ;
  p.pq := p2 ;
  p.us := p3 ;
  return MsgFilter (p) ;
end GuiMsgFilter ;

type HWHP is record
hw : HWND ;
hp : HPS  ;
end record ;

procedure   GuiFillBackground (p1:HWND; p2:HPS) is
procedure   FillBackground (p :HWHP);
pragma Import(c,FillBackground, Link_name=>"_FillBackground");
p :HWHP;
begin
  p.hw := p1 ;
  p.hp := p2 ;
  FillBackground (p);
end GuiFillBackground;

type HWULULLO is record
  hw : HWND ;
  ul1: ULONG;
  ul2: ULONG;
  lo : LONG ;
end record ;

function  GuiGetPresRGB (p1:HWND; p2:ULONG; p3:ULONG; p4:LONG) return LONG  is
function  GetPresRGB (p :HWULULLO ) return LONG  ;
pragma Import(c,GetPresRGB, Link_name=>"_GetPresRGB");
p :HWULULLO ;
begin
  p.hw := p1;
  p.ul1:= p2;
  p.ul2:= p3;
  return GetPresRGB (p);
end GuiGetPresRGB;

type PWPLPLPLPL is record
pw : pwindow ;
pl1: PLONG;
pl2: PLONG;
pl3: PLONG;
pl4: PLONG;
end record ;

procedure   GuiGetClientRect (p1:PWINDOW; p2:PLONG; p3:PLONG; p4:PLONG; p5:PLONG) is
procedure   GetClientRect (p:PWPLPLPLPL );
pragma Import(c,GetClientRect, Link_name=>"_GetClientRect");
p:PWPLPLPLPL ;
begin
  p.pw := p1;
  p.pl1:= p2;
  p.pl2:= p3;
  p.pl3:= p4;
  p.pl4:= p5;
  GetClientRect (p);
end GuiGetClientRect ;

type HWHPO is record
hw : HWND ;
hpo: HPOINTER ;
end record ;

procedure   GuiSetMousePtr  (p1:HWND; p2:HPOINTER) is
procedure   SetMousePtr  (p :HWHPO);
pragma Import(c,SetMousePtr, Link_name=>"_SetMousePtr");
p :HWHPO ;
begin
p.hw := p1 ;
p.hpo:= p2 ;
SetMousePtr  (p);
end GuiSetMousePtr;

type PWPW is record
pw1 : pwindow ;
pw2 : pwindow ;
end record ;

function  GuiInvokeWindow (p1:PWINDOW; p2:PWINDOW) return SHORT   is
function  InvokeWindow (p :PWPW ) return SHORT  ;
pragma Import(c,InvokeWindow, Link_name=>"_InvokeWindow");
p : PWPW;
begin
  p.pw1 := p1 ;
  p.pw2 := p2 ;
  return InvokeWindow (p) ;
end GuiInvokeWindow ;

function  GuiLoadWindow (p1:PWINDOW; p2:PWINDOW) return BOOL  is
function  LoadWindow (p :PWPW) return BOOL  ;
pragma Import(c,LoadWindow, Link_name=>"_LoadWindow");
p : PWPW;
begin
  p.pw1 := p1 ;
  p.pw2 := p2 ;
  return LoadWindow (p) ;
end GuiLoadWindow ;

type PWSH is record
pw : PWINDOW ;
sh : SHORT   ;
end record ;

procedure   GuiDismissWindow      (p1:PWINDOW; p2:SHORT) is
procedure   DismissWindow      (p :PWSH );
pragma Import(c,DismissWindow, Link_name=>"_DismissWindow");
p :PWSH ;
begin
p.pw := p1 ;
p.sh := p2 ;
DismissWindow  (p);
end GuiDismissWindow ;

type PWHW is record
pw : PWINDOW ;
hw : HWND    ;
end record ;

procedure   GuiGetWindow   (p1:PWINDOW;p2: HWND) is
procedure   GetWindow   (p :PWHW);
pragma Import(c,GetWindow, Link_name=>"_GetWindow");
p :PWHW ;
begin
  p.pw := p1 ;
  p.hw := p2 ;
  GetWindow   (p);
end GuiGetWindow ;

type PWLOGSPFHM is record
pw : PWINDOW ;
lo : LONG ;
gs : GuiStr;
pf : PFNWP ;
hm : HMODULE;
end record ;

procedure   GuiSetWindow  (p1:PWINDOW;p2: LONG;p3: string;p4: PFNWP;p5: HMODULE) is
procedure   SetWindow  (p :PWLOGSPFHM );
pragma Import(c,SetWindow,Link_name => "SetWindow");

p :PWLOGSPFHM ;
begin
  p.pw := p1;
  p.lo := p2;
  p.gs := To_guistr(p3) ;
  p.pf := p4;
  p.hm := p5;
  SetWindow  (p) ;
end GuiSetWindow ;

function   GuiLoadMainWindow  (p1: LONG;p2: string;p3: PFNWP;p4: HMODULE) return WINDOW is
function    LoadMainWindow  (p1: LONG;p2: GuiStr;p3: PFNWP;p4: HMODULE) return WINDOW;
pragma Import(c,LoadMainWindow,Link_name => "_LoadMainWindow");
-- p1 : WINDOW ;
begin
--  p1.szType := (others => character'val(0));
--  p1.szType(1..p3'length) := p3 ;
--  p1.lID                  := p2 ;
--  p1.p_fnwp               := p4 ;
--  p1.h_Module             := p5;
  return   LoadMainWindow  (p1,To_Guistr(p2),p3,p4) ;
end GuiLoadMainWindow ;

type PWPWLOGS is record
pw1: PWINDOW ;
pw2: PWINDOW ;
lo : LONG    ;
gs : GuiStr  ;
end record ;

procedure   GuiSetControl  (p1:PWINDOW; p2:PWINDOW; p3:LONG; p4:string) is
procedure   SetControl  (p :PWPWLOGS);
pragma Import(c,SetControl, Link_name=>"_SetControl");
p :PWPWLOGS ;
begin
p.pw1 := p1 ;
p.pw2 := p2 ;
p.lo  := p3 ;
p.gs  := To_guistr(p4) ;
SetControl  (p) ;
end GuiSetControl ;

type PWLOLO is record
pw : PWINDOW ;
lo1: LONG    ;
lo2: LONG    ;
end record ;

procedure   GuiSetColor    (p1:PWINDOW; p2:LONG; p3:LONG) is
procedure   SetColor    (p :PWLOLO);
pragma Import(c,SetColor, Link_name=>"_SetColor");
p :PWLOLO ;
begin
  p.pw := p1 ;
  p.lo1:= p2 ;
  p.lo2:= p3 ;
  SetColor    (p);
end GuiSetColor ;

type PWLO is record
pw : PWINDOW ;
lo : LONG    ;
end record ;

function   GuiGetColor  (p1:PWINDOW; p2:LONG) return LONG   is
function   GetColor  (p :PWLO) return LONG  ;
pragma Import(c,GetColor, Link_name=>"_GetColor");
p :PWLO ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  return GetColor  (p);
end GuiGetColor ;

type PWGS is record
pw : PWINDOW ;
gs : GuiStr ;
end record ;

procedure   GuiSetFont    (p1:PWINDOW; p2:string) is
procedure   SetFont    (p :PWGS);
pragma Import(c,SetFont, Link_name=>"_SetFont");
p :PWGS ;
begin
  p.pw := p1 ;
  p.gs := To_guistr(p2) ;
  SetFont(p);
end GuiSetFont ;

type GSPF is record
gs : GuiStr;
pf : PFATTRS ;
end record ;

function  GuiFontAttrs (p1:string; p2:PFATTRS) return BOOL  is
function  FontAttrs (p :GSPF) return BOOL  ;
pragma Import(c,FontAttrs, Link_name=>"_FontAttrs");
p :GSPF ;
begin
   p.gs := To_guistr(p1);
   p.pf := p2 ;
   return FontAttrs (p);
end GuiFontAttrs ;

function GuiGetShort (p1:PWINDOW; p2:LONG) return SHORT    is
function GetShort (p :PWLO) return SHORT   ;
pragma Import(c,GetShort, Link_name=>"_GetShort");
p :PWLO ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  return GetShort  (p);
end GuiGetShort ;

type PWLOSH is record
pw : PWINDOW ;
lo : LONG    ;
sh : SHORT   ;
end record ;

procedure   GuiSetShort  (p1:PWINDOW; p2:LONG; p3:SHORT) is
procedure   SetShort  (p :PWLOSH);
pragma Import(c,SetShort, Link_name=>"_SetShort");
p :PWLOSH ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  p.sh := p3 ;
  SetShort  (p) ;
end GuiSetShort ;

function  GuiGetLong  (p1:PWINDOW; p2:LONG) return LONG  is
function  GetLong  (p :PWLO) return LONG   ;
pragma Import(c,GetLong, Link_name=>"_GetLong");
p :PWLO ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  return GetLong  (p);
end GuiGetLong ;

procedure   GuiSetLong  (p1:PWINDOW; p2:LONG; p3:LONG) is
procedure   SetLong  (p :PWLOLO );
pragma Import(c,SetLong, Link_name=>"_SetLong");
p :PWLOLO ;
begin
  p.pw := p1 ;
  p.lo1:= p2 ;
  p.lo2:= p3 ;
  SetLong  (p);
end GuiSetLong ;

function GuiGetReal (p1:PWINDOW;p2: LONG) return double is
function GetReal (p :PWLO) return double  ;
pragma Import(c,GetReal, Link_name=>"_GetReal");
p :PWLO ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  return GetReal  (p);
end GuiGetReal ;

type PWLORE is record
pw : PWINDOW ;
lo : LONG    ;
re : REAL    ;
end record ;

procedure   GuiSetReal  (p1:PWINDOW; p2:LONG; p3:REAL) is
procedure   SetReal  (p :PWLORE );
pragma Import(c,SetReal, Link_name=>"_SetReal");
p :PWLORE ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  p.re := p3 ;
  SetReal  (p) ;
end GuiSetReal ;

type PWLOGS is record
pw : PWINDOW ;
lo : LONG    ;
gs : GuiStr  ;
end record ;
type PPWLOGS is access all  PWLOGS ;

function GuiGetString  (p1:PWINDOW; p2:LONG) return string is
procedure GetString  (p :PPWLOGS) ;
pragma Import(c,GetString, Link_name=>"_GetString");
p :aliased PWLOGS ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  GetString(p'unchecked_access);
  return From_GuiStr(p.gs);
end GuiGetString ;

procedure   GuiSetString   (p1:PWINDOW; p2:LONG; p3:string) is
procedure   SetString   (p :PWLOGS );
pragma Import(c,SetString, Link_name=>"_SetString");
p :PWLOGS ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  p.gs := To_guistr(p3) ;
  SetString (p);
end GuiSetString ;

function  GuiGetImage  (p1:PWINDOW; p2:LONG) return Image  is
function  GetImage  (p :PWLO) return Image  ;
pragma Import(c,GetImage, Link_name=>"_GetImage");
p :PWLO ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  return GetImage (p);
end GuiGetImage;

type PWLOIM is record
pw : PWINDOW ;
lo : LONG    ;
im : IMAGE   ;
end record ;

procedure   GuiSetImage (p1:PWINDOW; p2:LONG; p3:Image) is
procedure   SetImage (p :PWLOIM );
pragma Import(c,SetImage, Link_name=>"_SetImage");
p :PWLOIM ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  p.im := p3 ;
  SetImage (p);
end GuiSetImage ;

function  GuiGetPtr  (p1:PWINDOW; p2:LONG) return PVOID  is
function  GetPtr  (p :PWLO) return PVOID  ;
pragma Import(c,GetPtr, Link_name=>"_GetPtr");
p :PWLO ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  return GetPtr (p);
end GuiGetPtr;

type PWLOPV is record
pw : PWINDOW ;
lo : LONG    ;
pv : PVOID   ;
end record ;

procedure   GuiSetPtr  (p1:PWINDOW; p2:LONG; p3:PVOID) is
procedure   SetPtr  (p :PWLOPV);
pragma Import(c,SetPtr, Link_name=>"_SetPtr");
p :PWLOPV ;
begin
  p.pw := p1 ;
  p.lo := p2 ;
  p.pv := p3 ;
  SetPtr  (p);
end GuiSetPtr ;


function GuiSendMsg (p1:HWND;p2:ULONG;p3:PMPARAM;p4:PMPARAM) return MRESULT is
function SendMsg (p :HWULMPMP) return MRESULT ;
pragma Import(c,SendMsg, Link_name=>"_SendMsg");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return SendMsg (p);
end GuiSendMsg ;

procedure   GuiBroadcastMsg (p1:HWND; p2:ULONG; p3:PMPARAM; p4:PMPARAM) is
procedure   BroadcastMsg (p :HWULMPMP);
pragma Import(c,BroadcastMsg, Link_name=>"_BroadcastMsg");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  BroadcastMsg    (p);
end GuiBroadcastMsg;

function GuiTabbing (p1:HWND; p2:ULONG; p3:PMPARAM;p4:PMPARAM) return BOOL is
function Tabbing (p :HWULMPMP) return BOOL   ;
pragma Import(c,Tabbing, Link_name=>"_Tabbing");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return Tabbing (p);
end GuiTabbing;

type PFHWULMPMP is record
pf : PFNWP ;
hw : HWND  ;
ul : ULONG ;
mp1: PMPARAM;
mp2: PMPARAM;
end record ;

function GuiDefFrameProc (p1:PFNWP; p2:HWND; msg:ULONG;mp1:PMPARAM;mp2:PMPARAM) return Ulong is
function DefFrameProc (p :PFHWULMPMP) return Ulong ;
pragma Import(c,DefFrameProc,Link_name=>"_DefFrameProc");
p :PFHWULMPMP ;
begin
p.pf := p1 ;
p.hw := p2 ;
p.ul := msg;
p.mp1:=mp1 ;
p.mp2:=mp2 ;
  return DefFrameProc (p) ;
end GuiDefFrameProc ;

function GuiDefWinProc   (p1:PFNWP; p2:HWND; p3:ULONG;p4:PMPARAM;p5:PMPARAM) return Ulong is
function DefWinProc   (p :PFHWULMPMP) return Ulong ;
pragma Import(c,DefWinProc, Link_name=>"_DefWinProc");
p :PFHWULMPMP ;
begin
p.pf := p1 ;
p.hw := p2 ;
p.ul := p3 ;
p.mp1:= p4 ;
p.mp2:= p5 ;
  return DefWinProc (p) ;
end GuiDefWinProc ;

function  GuiFrameCtlProc (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong is
function  FrameCtlProc  (p :HWULMPMP) return Ulong;
pragma Import(c,FrameCtlProc, Link_name=>"_FrameCtlProc");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return FrameCtlProc (p);
end GuiFrameCtlProc ;

function  GuiMenuCtlProc (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong is
function  MenuCtlProc (p :HWULMPMP) return Ulong ;
pragma Import(c,MenuCtlProc, Link_name=>"_MenuCtlProc");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return MenuCtlProc (p);
end GuiMenuCtlProc ;

function  GuiButtonCtlProc (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong is
function  ButtonCtlProc (p :HWULMPMP) return Ulong;
pragma Import(c,ButtonCtlProc, Link_name=>"_ButtonCtlProc");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return ButtonCtlProc  (p);
end GuiButtonCtlProc   ;

function  GuiComboboxCtlProc    (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong is
function  ComboboxCtlProc  (p1:HWULMPMP) return Ulong;
pragma Import(c,ComboboxCtlProc, Link_name=>"_ComboboxCtlProc");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return ComboboxCtlProc(p);
end GuiComboboxCtlProc ;

function  GuiEntryCtlProc  (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong is
function  EntryCtlProc  (p :HWULMPMP) return Ulong;
pragma Import(c,EntryCtlProc, Link_name=>"_EntryCtlProc");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return EntryCtlProc   (p);
end GuiEntryCtlProc    ;

function  GuiListboxCtlProc  (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong is
function  ListboxCtlProc     (p :HWULMPMP) return Ulong;
pragma Import(c,ListboxCtlProc, Link_name=>"_ListboxCtlProc");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return ListboxCtlProc   (p);
end GuiListboxCtlProc  ;

function  GuiMLECtlProc     (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong is
function  MLECtlProc     (p :HWULMPMP) return Ulong;
pragma Import(c,MLECtlProc, Link_name=>"_MLECtlProc");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return MLECtlProc       (p);
end GuiMLECtlProc      ;

function  GuiScrollbarCtlProc   (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong is
function  ScrollbarCtlProc   (p :HWULMPMP) return Ulong;
pragma Import(c,ScrollbarCtlProc, Link_name=>"_ScrollbarCtlProc");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return ScrollbarCtlProc (p);
end GuiScrollbarCtlProc;

function  GuiStaticCtlProc      (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong is
function  StaticCtlProc      (p :HWULMPMP) return Ulong;
pragma Import(c,StaticCtlProc, Link_name=>"_StaticCtlProc");
p :HWULMPMP ;
begin
  p.hw := p1 ;
  p.ul := p2 ;
  p.mp1:= p3 ;
  p.mp2:= p4 ;
  return StaticCtlProc (p);
end GuiStaticCtlProc;

type PWSHGS is record
pw : PWINDOW ;
sh : SHORT   ;
gs : GUISTR  ;
end record ;
type PPWSHGS is access all PWSHGS ;

function GuiInsertItem (p1:PWINDOW;p2:SHORT;p3:String) return SHORT  is
function InsertItem (p :PWSHGS) return SHORT   ;
pragma Import(c,InsertItem, Link_name=>"_InsertItem");
p :PWSHGS ;
begin
  p.pw := p1 ;
  p.sh := p2 ;
  p.gs := To_guistr(p3) ;
  return InsertItem (p) ;
end GuiInsertItem ;

procedure   GuiDeleteItem (p1:PWINDOW; p2:SHORT) is
procedure   DeleteItem (p :PWSH);
pragma Import(c,DeleteItem, Link_name=>"_DeleteItem");
p :PWSH ;
begin
  p.pw :=p1 ;
  p.sh :=p2 ;
  DeleteItem (p);
end GuiDeleteItem ;

function GuiGetItemText (p1:PWINDOW;p2: SHORT) return String is
procedure GetItemText (p :PPWSHGS) ;
pragma Import(c,GetItemText, Link_name=>"_GetItemText");
p : aliased PWSHGS ;
begin
  p.pw :=p1 ;
  p.sh :=p2 ;
  GetItemText(p'unchecked_access) ;
  return  From_guistr(p.gs) ;
end GuiGetItemText;

procedure   GuiSetItemText  (p1:PWINDOW; p2:SHORT; p3:String) is
procedure   SetItemText  (p :PWSHGS);
pragma Import(c,SetItemText, Link_name=>"_SetItemText");
p :PWSHGS ;
begin
  p.pw := p1 ;
  p.sh := p2 ;
  p.gs := To_guistr(p3) ;
  SetItemText(p) ;
end GuiSetItemText;

function  GuiGetItemHandle  (p1:PWINDOW; p2:SHORT) return LONG is
function  GetItemHandle  (p :PWSH) return LONG  ;
pragma Import(c,GetItemHandle, Link_name=>"_GetItemHandle");
p :PWSH ;
begin
  p.pw := p1 ;
  p.sh := p2 ;
  return GetItemHandle  (p);
end GuiGetItemHandle ;

type PWSHLO is record
pw : PWINDOW ;
sh : SHORT   ;
lo : LONG    ;
end record ;

procedure   GuiSetItemHandle  (p1:PWINDOW; p2:SHORT; p3:LONG) is
procedure   SetItemHandle  (p :PWSHLO);
pragma Import(c,SetItemHandle, Link_name=>"_SetItemHandle");
p :PWSHLO ;
begin
  p.pw := p1 ;
  p.sh := p2 ;
  p.lo := p3 ;
  SetItemHandle  (p);
end GuiSetItemHandle ;

type PWSHBO is record
pw  : PWINDOW ;
sh  : SHORT   ;
bo  : BOOL    ;
end record ;

procedure   GuiSelectItem  (p1:PWINDOW;p2:SHORT; p3:BOOL) is
procedure   SelectItem  (p :PWSHBO);
pragma Import(c,SelectItem, Link_name=>"_SelectItem");
p :PWSHBO ;
begin
  p.pw := p1 ;
  p.sh := p2 ;
  p.bo := p3 ;
  SelectItem  (p);
end GuiSelectItem ;

function GuiNextSelection  (p1:PWINDOW; p2:SHORT) return SHORT  is
function NextSelection  (p :PWSH) return SHORT   ;
pragma Import(c,NextSelection, Link_name=>"_NextSelection");
p :PWSH ;
begin
  p.pw := p1 ;
  p.sh := p2 ;
  return NextSelection (p);
end GuiNextSelection ;

function GuiMod (p1:integer; p2:integer) return integer is
begin
return p1 mod p2;
end GuiMod ;

function GuiMod (p1:SHORT; p2:SHORT) return SHORT is
begin
return p1 mod p2;
end GuiMod ;

function GuiMod(p1:LONG;p2: LONG) return LONG  is
begin
return p1 mod p2;
end GuiMod ;

-- function  GuiMod (p1:SREAL;p2:SREAL) return SREAL is
-- p ,absp1, absp2 : SREAL ;
-- k : integer ;
-- begin
--  absp1 := abs p1;
--  absp2 := abs p2;
--  if absp1 < absp2  or absp1 = 0.0 or absp2 = 0.0 then return p1 ; end if;
--  k  := integer(p1/p2);
--  absp1 := absp1 - SREAL(k)*absp2 ;
--  if p1 > 0.0 then return absp1 ; else return -absp1 ; end if;
-- end GuiMod ;

function  GuiMod(p1:REAL;p2:REAL) return REAL is
absp1, absp2 : REAL ;
k : integer ;
begin
  absp1 := abs p1;
  absp2 := abs p2;
  if absp1 < absp2  or absp1 = 0.0 or absp2 = 0.0 then return p1 ; end if;
  k  := integer(p1/p2);
  absp1 := absp1 - REAL(k)*absp2 ;
  if p1 > 0.0 then return absp1 ; else return -absp1 ; end if;
end GuiMod ;

function GuiMod (p1:LREAL;p2:LREAL) return LREAL is
absp1, absp2 : LREAL ;
k : integer ;
begin
  absp1 := abs p1;
  absp2 := abs p2;
  if absp1 < absp2  or absp1 = 0.0 or absp2 = 0.0 then return p1 ; end if;
  k  := integer(p1/p2);
  absp1 := absp1 - LREAL(k)*absp2 ;
  if p1 > 0.0 then return absp1 ; else return -absp1 ; end if;
end GuiMod ;

type LOLOLO is record
lo1 : LONG;
lo2 : LONG;
lo3 : LONG;
end record ;

procedure   GuiMoveTo (p1:LONG;p2:LONG;p3:LONG) is
procedure   MoveTo (p :LOLOLO);
pragma Import(c,MoveTo, Link_name=>"_MoveTo");
p :LOLOLO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  p.lo3 := p3;
  MoveTo (p);
end GuiMoveTo ;

procedure   GuiLineTo (p1:LONG;p2:LONG;p3:LONG) is
procedure   LineTo (p :LOLOLO);
pragma Import(c,LineTo, Link_name=>"_LineTo");
p :LOLOLO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  p.lo3 := p3;
  LineTo (p);
end GuiLineTo ;

type LOLOLOLOLO is record
lo1 : LONG;
lo2 : LONG;
lo3 : LONG;
lo4 : LONG;
lo5 : LONG;
end record ;

procedure   GuiDrawLine (p1:LONG;p2:LONG;p3:LONG;p4:LONG;p5:LONG) is
procedure   DrawLine (p :LOLOLOLOLO);
pragma Import(c,DrawLine, Link_name=>"_DrawLine");
p :LOLOLOLOLO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  p.lo3 := p3;
  p.lo3 := p4;
  p.lo3 := p5;
  DrawLine (p) ;
end GuiDrawLine ;

type LOLOLOLOBO is record
lo1 : LONG;
lo2 : LONG;
lo3 : LONG;
lo4 : LONG;
bo  : BOOL;
end record ;

procedure   GuiDrawBox  (p1:LONG;p2:LONG;p3:LONG;p4:LONG;p5:BOOL) is
procedure   DrawBox  (p :LOLOLOLOBO);
pragma Import(c,DrawBox, Link_name=>"_DrawBox");
p :LOLOLOLOBO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  p.lo3 := p3;
  p.lo3 := p4;
  p.bo  := p5;
  DrawBox (p) ;
end GuiDrawBox ;

type LOLOBO is record
lo1 : LONG;
lo2 : LONG;
bo  : BOOL;
end record ;

procedure   GuiDrawCircle (p1:LONG;p2:LONG;p3:BOOL) is
procedure   DrawCircle (p :LOLOBO);
pragma Import(c,DrawCircle, Link_name=>"_DrawCircle");
p :LOLOBO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  p.bo  := p3;
  DrawCircle (p);
end GuiDrawCircle ;

type LOLOLOBO is record
lo1 : LONG;
lo2 : LONG;
lo3 : LONG;
bo  : BOOL;
end record ;

procedure   GuiDrawEllipse (p1:LONG;p2:LONG;p3:LONG;p4:BOOL) is
procedure   DrawEllipse (p :LOLOLOBO);
pragma Import(c,DrawEllipse, Link_name=>"_DrawEllipse");
p :LOLOLOBO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  p.lo3 := p3;
  p.bo  := p4;
  DrawEllipse (p);
end GuiDrawEllipse ;

type LOGS is record
lo : LONG ;
gs : GUISTR;
end record ;

procedure   GuiDrawText (p1:LONG;p2: string) is
procedure   DrawText (p :LOGS);
pragma Import(c,DrawText, Link_name=>"_DrawText");
p :LOGS ;
begin
  p.lo := p1;
  p.gs := To_guistr(p2) ;
  DrawText (p);
end GuiDrawText ;

type LOIMLO is record
lo1 : LONG ;
im  : IMAGE;
lo2 : LONG ;
end record ;

procedure   GuiDrawImage  (p1:LONG;p2:Image;p3:LONG) is
procedure   DrawImage  (p :LOIMLO);
pragma Import(c,DrawImage, Link_name=>"_DrawImage");
p :LOIMLO ;
begin
  p.lo1 := p1 ;
  p.im  := p2 ;
  p.lo2 := p3 ;
  DrawImage  (p);
end GuiDrawImage ;

procedure   GuiSetDrawColor (p1:LONG;p2:LONG) is
procedure   SetDrawColor (p :LOLO);
pragma Import(c,SetDrawColor, Link_name=>"_SetDrawColor");
p :LOLO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  SetDrawColor (p);
end GuiSetDrawColor ;

procedure   GuiSetBackColor  (p1:LONG;p2:LONG) is
procedure   SetBackColor  (p :LOLO);
pragma Import(c,SetBackColor, Link_name=>"_SetBackColor");
p :LOLO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  SetBackColor (p);
end GuiSetBackColor ;

procedure   GuiSetSysColor  (p1:LONG;p2:LONG) is
procedure   SetSysColor  (p :LOLO);
pragma Import(c,SetSysColor, Link_name=>"_SetSysColor");
p :LOLO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  SetSysColor (p);
end GuiSetSysColor ;

procedure  GuiSetLineType (p1:LONG;p2:LONG) is
procedure  SetLineType (p :LOLO);
pragma Import(c,SetLineType, Link_name=>"_SetLineType");
p :LOLO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  SetLineType (p);
end GuiSetLineType ;

procedure   GuiSetFillPattern     (p1:LONG;p2:LONG) is
procedure   SetFillPattern     (p :LOLO);
pragma Import(c,SetFillPattern, Link_name=>"_SetFillPattern");
p :LOLO ;
begin
  p.lo1 := p1;
  p.lo2 := p2;
  SetFillPattern  (p);
end GuiSetFillPattern    ;

function GuiVal(s:string) return Long is
function Val(st:GuiStr) return Long;
Pragma Import(c,Val,link_Name =>"_GuiVal__FPCc");
st: GuiStr;
begin
st := To_Guistr(s);
return Val(st);
end GuiVal;

type PFPF is record
pf1  : PFNVOID ;
pf2  : PFNVOID ;
end record ;

function GuiRecordDLL (p1:PFNVOID;p2: PFNVOID) return BOOL is
function RecordDLL (p :PFPF) return BOOL   ;
pragma Import(c,RecordDLL, Link_name=>"_RecordDLL");
p :PFPF ;
begin
  p.pf1 := p1;
  p.pf2 := p2;
  return RecordDLL (p);
end GuiRecordDLL ;

type PWLOLOULGS is record
pw : PWINDOW ;
lo1: LONG ;
lo2: LONG ;
ul : ULONG;
gs : GuiStr;
end record ;

procedure GuiDrawImageFromFile(pw:pwindow;          -- window
                               x,y:long;            -- x,y coordinats
                               file_name:string;    -- full file name
                               drw : ulong := GUIDRW_NORMAL ) is
procedure DrawImageFromFile (p: PWLOLOULGS);
pragma Import(c,DrawImageFromFile,Link_name => "_DrawImageFromFile");
p: PWLOLOULGS ;
begin
 p.pw := pw; p.lo1 := x; p.lo2 := y; p.ul := drw;
 p.gs := To_guistr(file_name);
 DrawImageFromFile (p);

end GuiDrawImageFromFile ;

function  GuiSetImageFromFile(File_Name : string) return Image is
function  SetImageFromFile (f: Guistr) return Image ;
pragma Import(c,SetImageFromFile,Link_name => "_SetImageFromFile");
f: GuiStr     ;
begin
 f  := To_guistr(file_name);
 return SetImageFromFile (f);
end GuiSetImageFromFile ;

function GuiHelpSetUp(papp: PAPPINFO;Panel_Id:Ulong) return HELPINIT is
hmi     : aliased HELPINIT;
HelpTab : constant ULong := 16#FFFF0000# or IDHT_GUIMAIN ;
function Ulong_to_PHELPTABLE is
    new Ada.Unchecked_conversion(Source => Ulong,Target => PHELPTABLE);
begin

    hmi.cb                       := HELPINIT'size/8 ;
    hmi.ulReturnCode             := 0 ;
    hmi.pszTutorialName          := System.Null_Address;
    hmi.phtHelpTable             := Ulong_to_PHELPTABLE(HelpTab) ;
    hmi.hmodHelpTableModule      := 0;
    hmi.hmodAccelActionBarModule := 0;
    hmi.idAccelTable             := 0;
    hmi.idActionBar              := 0;
    hmi.pszHelpWindowTitle       := pApp.szPgmTitle'address;
--  hmi.fShowPanelId             := Ulong(CMIC_HIDE_PANEL_ID);
    hmi.fShowPanelId             := Panel_ID ;
    hmi.pszHelpLibraryName       := pApp.szHlpFile'address;

    pApp.hwndHelp := WinCreateHelpInstance (pApp.h_ab, hmi'unchecked_access);
    if  hmi.ulReturnCode /= 0 then  pApp.hwndHelp := 0; end if;
 return hmi;
end GuiHelpSetUp ;

procedure GuiAddEntry(papp:APPINFO;wMainFrame:WINDOW) is

 --     * Add entry to tasklist *

swctl   : aliased os2.pmcp.SWCNTRL :=
            ( hwn            => 0, hwndIcon       => 0,
              hprog          => 0, idProcess      => 0,
              idSession      => 0, uchVisibility  => 0,
              fbJump         => 0,
              szSwtitle      => (others => character'val(0) ),
              bProgType      => 0 );
begin
for kk in 1..swctl.szSwtitle'length loop
     swctl.szSwtitle(kk) := pApp.szPgmTitle(kk);
end loop;

swctl.hwn           := wMainFrame.h_wnd;
swctl.idProcess     := pApp.p_id;
swctl.uchVisibility := SWL_VISIBLE;
swctl.fbJump        := SWL_JUMPABLE;

if WinAddSwitchEntry (swctl'unchecked_access) > 0 then null; end if;
end;

function GuiInvokeApplication(
 ApplicationName:string  ; -- Name of application
 Title          :string  ; -- Title of main Window
 WindowClass    :string  ; -- Name of Window Class
 IDD_MAINFRAME  :LONG    ; -- Number of resurce connected with Window
 pwMainFrame    :PWINDOW ; -- Main Application Window pointer
 DialogWndProc  :PFNWP   ) -- Name of Dialog Function
                             return PAPPINFO is
 swctl   : aliased os2.pmcp.SWCNTRL :=
             ( hwn            => 0, hwndIcon       => 0,
               hprog          => 0, idProcess      => 0,
               idSession      => 0, uchVisibility  => 0,
               fbJump         => 0,
               szSwtitle      => (others => character'val(0) ),
               bProgType      => 0 );

function InitApplication(
 Application_Name:GuiStr  ; -- Name of application
 Title_Name      :GuiStr  ; -- Title of main Window
 Window_Class    :GuiStr  ; -- Name of Window Class
 IDD_MAINFRAME   :LONG    ; -- Number of resurce connected with Window
 pwMainFrame     :PWINDOW ; -- Main Application Window pointer
 DialogWndProc   :PFNWP   ) -- Name of Dialog Function
                             return PAPPINFO ;
pragma Import(c,InitApplication,Link_Name=>"_InitApplication");
begin
pApp := InitApplication(To_guistr(ApplicationName),
                        To_guistr(Title),To_guistr(WindowClass),
                        IDD_MAINFRAME,pwMainFrame ,DialogWndProc);
 --     * Add entry to tasklist *

for kk in 1..swctl.szSwtitle'length loop
     swctl.szSwtitle(kk) := pApp.szPgmTitle(kk);
end loop;
swctl.hwn           := pwMainFrame.h_wnd;
swctl.hwndIcon      := 0;
swctl.hprog         := 0;
swctl.idProcess     := pApp.p_id;
swctl.idSession     := 0;
swctl.uchVisibility := SWL_VISIBLE;
swctl.fbJump        := SWL_JUMPABLE;

if WinAddSwitchEntry (swctl'unchecked_access) > 0 then null; end if;

--      * Process the window template *

pApp.hwndMain := pwMainFrame.h_wnd;
if GuiProcessWindow (pwMainFrame) >0 then null;end if;
if GuiUnloadWindow (pwMainFrame) > 0 then null; end if;

--  * Termination processing *

if  pApp.hwndHelp > 0 then
    if WinDestroyHelpInstance (pApp.hwndHelp) >0 then null; end if;
end if;
return pApp;
end GuiInvokeApplication;


function GuiInvokeDialogWindow(
 Title            :string  ; -- Title of dialog Window
 WindowClass      :string  ; -- Name of Window Class
 IDD_DIALOGFRAME  :LONG    ; -- Number of resurce connected with Window
 pwParentFrame    :PWINDOW ; -- Main Application Window pointer
 pwDialogFrame    :PWINDOW ; -- Main Application Window pointer
 DialogWndProc    :PFNWP   ) -- Name of Dialog Function
                         return APIRET  is
begin
 GuiSetWindow (pwDialogFrame,IDD_DIALOGFRAME,WindowClass,DialogWndProc,0);
 if Title'length > 0 then
   if WinSetWindowText(pwDialogFrame.h_wnd,Title'address)>0 then Null; end if;
 end if;
 return APIRET(GuiInvokeWindow (pwDialogFrame,pwParentFrame ));
end;

function  GuiStrLower (s:string ) return string is
begin
return s;
end ;
function  GuiStrUpper (s:string ) return string is
begin
return s;
end ;
function  GuiStrLeft (s:string; size: integer) return string is
begin
return s;
end ;
function  GuiStrMid (s:string; start, size: integer) return string is
begin
return s;
end ;
function  GuiStrRight (s:string; size: integer) return string is
begin
return s;
end ;
function GuiStrTrim(s:string) return string is -- delete blanks
len,ib,ie: integer ;
begin  len:=s'length;
  for k in 1..len loop if s(k) /= ' ' then ib:=k; exit; end if; end loop;
  for k in reverse 1..len loop if s(k) /= ' ' then ie:=k; exit; end if; end loop;
  return s(ib..ie);
end GuiStrTrim ;

function  GuiStrLTrim (s:string ) return string is
begin
return s;
end ;
function  GuiStrRTrim (s:string ) return string is
begin
return s;
end ;
function  GuiStrRepeat (char:character; repeat:integer ) return string is
s:string(1..repeat);
begin  for i in 1..repeat loop s(i) := char; end loop;
return s;
end ;
function  GuiStrSearch (s:string; sub:string; start: integer)return integer is
begin
return 1;
end ;
function  GuiStrFill (s:string; size:integer; filler:string)return string is
begin
return s;
end ;
function  GuiToString (p:pvoid; size:integer) return string is
s:string(1..size); for s'address use p;
begin
return s;
end ;

procedure StaticText(pwin:PWINDOW;TXT:string;IDD_EVENT:Long )  is
GuiTmp1 : aliased window ;
begin
  GuiSetControl (pwin, GuiTmp1'unchecked_access,
                 IDD_EVENT, WT_STATICTEXT);
  GuiSetString (GuiTmp1'unchecked_access, WPID_TEXT, TXT);
end StaticText ;

end Os2.Jba;
